Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.crypto
Class CipherInputStream

    java.lang.Object
      |
      +--java.io.InputStream
            |
            +--java.io.FilterInputStream
                  |
                  +--javax.crypto.CipherInputStream

public class CipherInputStream
extends FilterInputStream

A CipherInputStream is composed of an InputStream and a Cipher so that read() methods return data that are read in from the underlying InputStream but have been additionally processed by the Cipher. The Cipher must be fully initialized before being used by a CipherInputStream.

For example, if the Cipher is initialized for decryption, the CipherInputStream will attempt to read in data and decrypt them, before returning the decrypted data.

This class adheres strictly to the semantics, especially the failure semantics, of its ancestor classes java.io.FilterInputStream and java.io.InputStream. This class has exactly those methods specified in its ancestor classes, and overrides them all. Moreover, this class catches all exceptions that are not thrown by its ancestor classes. In particular, the skip(long) method skips only data that have been processed by the Cipher.

It is crucial for a programmer using this class not to use methods that are not defined or overridden in this class (such as a new method or c onstructor that is later added to one of the super classes), because the design and implementation of those methods are unlikely to have considered security impact with regard to CipherInputStream.

See Also:
  `InputStream`, `FilterInputStream`, `Cipher`, `CipherOutputStream`

Fields inherited from class java.io.FilterInputStream
`in`

Constructor Summary
`protected` | `CipherInputStream(InputStream is)` Constructs a CipherInputStream from an InputStream without specifying a Cipher.
`` | `CipherInputStream(InputStream is, Cipher c)` Constructs a CipherInputStream from an InputStream and a Cipher.

Method Summary
`int` | `available()` Returns the number of bytes that can be read from this input stream without blocking.
`void` | `close()` Closes this input stream and releases any system resources associated with the stream.
`boolean` | `markSupported()` Tests if this input stream supports the mark and reset methods, which it does not.
`int` | `read()` Reads the next byte of data from this input stream.
`int` | `read(byte[] b)` Reads up to b.length bytes of data from this input stream into an array of bytes.
`int` | `read(byte[] b, int off, int len)` Reads up to len bytes of data from this input stream into an array of bytes.
`long` | `skip(long n)` Skips over and discards n bytes of data from this input stream.

Methods inherited from class java.io.FilterInputStream
`mark, reset`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CipherInputStream

    public CipherInputStream(InputStream is,
                             Cipher c)

  Constructs a CipherInputStream from an InputStream and a Cipher.

### CipherInputStream

    protected CipherInputStream(InputStream is)

  Constructs a CipherInputStream from an InputStream without specifying a Cipher. This has the effect of constructing a CipherInputStream using a NullCipher

Method Detail

### read

    public int read()
             throws IOException

  Reads the next byte of data from this input stream. The value byte is returned as an int in the range 0 to 255. If no byte is available because the end of the stream has been reached, the value -1 is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.
  Overrides:
    read in class FilterInputStream
  Returns:
    the next byte of data, or -1 if the end of the stream is reached.
  Throws:
    IOException - if an I/O error occurs.

### read

    public int read(byte[] b)
             throws IOException

  Reads up to b.length bytes of data from this input stream into an array of bytes.

  The read method of InputStream calls the read method of three arguments with the arguments b, 0, and b.length.

  Overrides:
    read in class FilterInputStream
  Returns:
    the total number of bytes read into the buffer, or -1 is there is no more data because the end of the stream has been reached.
  Throws:
    IOException - if an I/O error occurs.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException,
                    NullPointerException,
                    IndexOutOfBoundsException

  Reads up to len bytes of data from this input stream into an array of bytes. This method blocks until some input is available. If the first argument is null, up to len bytes are read and discarded.
  Overrides:
    read in class FilterInputStream
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the maximum number of bytes read.
  Returns:
    the total number of bytes read into the buffer, or -1 if there is no more data because the end of the stream has been reached.
  Throws:
    IOException - if an I/O error occurs.

### skip

    public long skip(long n)
              throws IOException

  Skips over and discards n bytes of data from this input stream. The skip method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly 0. The actual number of bytes skipped is returned.
  Overrides:
    skip in class FilterInputStream
  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    IOException - if an I/O error occurs.

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read from this input stream without blocking. The available method of InputStream returns 0. This method should be overridden by subclasses
  Overrides:
    available in class FilterInputStream
  Returns:
    the number of bytes that can be read from this input stream without blocking.
  Throws:
    IOException - if an I/O error occurs.

### close

    public void close()
               throws IOException

  Closes this input stream and releases any system resources associated with the stream.
  Overrides:
    close in class FilterInputStream
  Throws:
    IOException - if an I/O error occurs.

### markSupported

    public boolean markSupported()

  Tests if this input stream supports the mark and reset methods, which it does not.
  Overrides:
    markSupported in class FilterInputStream
  Returns:
    false, since this class does not support the mark and reset methods.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD